import Qt 4.7

Rectangle {
    width: 200
    height: 200

    // Fixed size, anchored to top-left corner of parent
    Rectangle {
        id: greenRect
        color: "green"
        anchors.top: parent.top
        anchors.left: parent.left
        width: 50
        height: 50
    }

    // Fixed width, dynamic height
    Rectangle {
        id: redRect
        color: "red"
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.bottom: magentaRect.top
        width: 50
    }

    // Dynamic width, between above two rectangles
    Rectangle {
        id: yellowRect
        color: "yellow"
        anchors.left: greenRect.right
        anchors.right: redRect.left
        anchors.top: parent.top
        height: 50
        Text {
            anchors.fill: parent
            text: yellowRect.width
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }
    }

    // Fixed size and position
    Rectangle {
        id: blackRect
        color: "black"
        x: 75
        y: 75
        width: 50
        height: 50
    }

    // Width not anchored, but calculated instead
    Rectangle {
        id: blueRect
        color: "lightblue"
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        width: yellowRect.width / 2
        height: 50
        Text {
            anchors.fill: parent
            text: blueRect.width
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }
    }

    // Fixed width, dynamic height
    Rectangle {
        id: grayRect
        color: "gray"
        anchors.left: blueRect.right
        anchors.bottom: parent.bottom
        anchors.top: blackRect.bottom
        height: 5000
        width: 50
    }

    // Dynamic width, fixed height
    Rectangle {
        id: magentaRect
        color: "magenta"
        anchors.left: grayRect.right
        anchors.right: parent.right
        anchors.bottom: parent.bottom
        height: 50
        width: 5000 // Left + right anchors override width
        Text {
            anchors.fill: parent
            text: magentaRect.width
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }
    }

}
