import Qt 4.7

Rectangle {

    property int seconds: 0
    property int minutes: 0
    property int hours: 0

    id: clockRect
    width: 200
    height: 200

    Rectangle {
        color: "black"
        width: 75
        height: 2
        x: 90
        y: 99

        // In this case jagged lines are clearly visible during
        // animation, so the smooth flag is always kept on
        smooth: true

        // Note: Compare with following
        // smooth: !rotationAnim.running

        transform: Rotation {
            origin.x: 10
            origin.y: 1
            angle: clockRect.seconds * 6 + 270
            // Example of RotationAnimation with Clockwise motion
            // Note: Compare with normal Property / NumberAnimation
            Behavior on angle {
                RotationAnimation {
                    id: rotationAnim
                    direction: RotationAnimation.Clockwise
                    duration: 500
                }
            }
        }
    }

    Rectangle {
        color: "red"
        width: 75
        height: 6
        x: 90
        y: 97
        smooth: true
        transform: Rotation {
            origin.x: 10
            origin.y: 3
            angle: clockRect.minutes * 6 + 270
        }
    }

    Rectangle {
        color: "red"
        width: 50
        height: 10
        x: 90
        y: 95
        smooth: true
        transform: Rotation {
            origin.x: 10
            origin.y: 5
            angle: clockRect.hours * 30 + 270 + clockRect.minutes / 2
        }
    }

}
