import Qt 4.7

// A delegate, which draws one item
Item {

    id: rootItem
    // Note use of 'view' attached property
    width: view.width
    height: 25

    Rectangle {
        id: tagRect
        width: 15
        height: 15
        x: 10
        y: (parent.height - height) / 2
        radius: 3
        color: "white"
        opacity: 0.0

        // Tagged state is entered when tagColor is set in model entry
        states: State {
            name: "tagged"
            when: tagColor && tagColor != "white"
            PropertyChanges {
                target: tagRect
                color: tagColor
                opacity: 1.0
            }
        }

        transitions: [
            Transition {
                NumberAnimation { property: "opacity" }
                ColorAnimation { property: "color" }
            }
        ]
    }

    // lastName and firstName come from model
    Text {
        x: 30
        y: 5
        width: view.width
        height: 15
        verticalAlignment: Text.AlignVCenter
        text: lastName + ", " + firstName
    }

    // Mouse click moves the item selection on top
    // of this item and also sets focus back to view
    // in case it has been moved somewhere else
    MouseArea {
        anchors.fill: parent
        onClicked: {
            view.focus = true
            view.currentIndex = index
        }
    }
}
