import Qt 4.7

Rectangle {
    id: rootRect
    width: 300
    height: 300

    property int detachCount: 0

    onDetachCountChanged: {
        console.log("Rectangles detached: " + detachCount)
    }

    // Flickable, which is filled with a grid of random-colored rectangles
    Flickable {
        anchors.fill: parent
        contentWidth: 2500
        contentHeight: 2500

        // Example how to temporarily disable flicking
        interactive: rootRect.detachCount < 3

        Grid {
            rows: 50
            columns: 50

            // Repeater generates a number child elements specified in model property
            Repeater {
                model: 2500
                GridRect { detachedParent: rootRect }
            }
        }
    }
}
