import Qt 4.7

Rectangle {

    property string text: ""

    // Focus property cannot be aliased, so must be forwarded
    onFocusChanged: focusScope.focus = focus

    id: rootRect
    width: 99
    height: 49

    // Draw a border if this has focus
    border.width: focusScope.activeFocus ? 1 : 0
    border.color: "red"

    // Each FocusScope may have an item with focus
    // That item has the global focus only if FocusScope has focus.
    FocusScope {
        id: focusScope
        anchors.fill: parent

        Text {
            id: textUpper
            text: rootRect.text + " - upper"
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: parent.top
            height: parent.height / 2
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter

            // Upper text has focus by default
            // Down-key moves focus to lower text
            focus: true
            Keys.onReturnPressed: console.log(text)
            KeyNavigation.down: textLower
            color: activeFocus ? "red" : "black"
        }
        Text {
            id: textLower
            text: rootRect.text + " - lower"
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.top: textUpper.bottom
            anchors.bottom: parent.bottom
            verticalAlignment: Text.AlignVCenter
            horizontalAlignment: Text.AlignHCenter

            // Up-key moves focus to upper text
            Keys.onReturnPressed: console.log(text)
            KeyNavigation.up: textUpper
            color: activeFocus ? "red" : "black"
        }
    }
}
