import Qt 4.7

Rectangle {
    width: 200
    height: 200

    Rectangle {
        id: redRect
        color: "red"
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.bottom: parent.bottom
        width: 100
    }

    Rectangle {
        id: yellowRect
        color: "yellow"
        anchors.left: redRect.right
        anchors.top: redRect.verticalCenter
        anchors.bottom: parent.bottom
        anchors.right: parent.right
    }

    Rectangle {
        id: dummyRect
        color: "red"
        width: 80; height: 20; x: 10; y: 25
    }

    Rectangle {
        id: blueRect
        color: "lightblue"
        anchors.top: dummyRect.bottom
        anchors.left: dummyRect.left
        anchors.right: dummyRect.right
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 10
        Text {
            text: parent.x + "," + parent.y
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: parent.verticalCenter
        }
    }

    // Re-parents and re-anchors the blue rectangle
    states: State {
        when: mouseArea.pressed

        // Changes parent to yellow rectangle
        ParentChange {
            target: blueRect
            parent: yellowRect
        }

        // AnchorChanges doesn't accept anchors.fill
        // Note: Demonstrate by switching order of
        // ParentChange and AnchorChanges
        AnchorChanges {
            target: blueRect
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottom: parent.bottom
        }

        // Anchor margins are PropertyChanges, not AnchorChanges
        // Note: Demonstrate also with margins: 10
        PropertyChanges {
            target: blueRect
            anchors.leftMargin: 10
            anchors.rightMargin: 10
            anchors.topMargin: 10
            anchors.bottomMargin: 10
        }

    }

    // When parent changes, the animations need to be wrapped
    // into ParentAnimation, so the property animations are
    // calculated correctly.
    // Note: Try without the parent animation
    //  -> Parent changes immediately and animation
    //     will be relative to new parent
    transitions: Transition {
        ParentAnimation {
            NumberAnimation { properties: "x,y,rotation" }
        }
        AnchorAnimation {}
    }


    MouseArea {
        anchors.fill: parent
        id: mouseArea
    }

}
