function loadItems(parentObj)
{
    // Case 1: Loads an object from string data
    var obj = Qt.createQmlObject('import Qt 4.7; Text { text: \"Hello World\" }', parentObj);
    obj.x = 66;
    obj.y = 93;

    // Case 2: Load component from QML file
    var cmp = Qt.createComponent('RedRect.qml');

    // General note:
    // When loaded from web, the loading might take
    // some time so the Ready status needs to be checked
    // before creating an instance of the component.
    // However, in this case this is not really necessary, as
    // the component is loaded from a file.
    if (cmp.status == Component.Ready) {
        console.log("Component was instantly loaded...");
        createObj(cmp, parentObj);
    } else {
        // Script functions can be hooked into signals
        // with connect function
        console.log("Component loading was delayed...");
        cmp.statusChanged.connect(createObjFunc(cmp, parentObj));
    }
}

// Returns a parameter-free function, which calls createObj
// with the correct parameters.
function createObjFunc(component, parentObj)
{
    return function() { createObj(component, parentObj); }
}

// Creates an instance of given component under given parent
function createObj(component, parentObj)
{
    if (component.status == Component.Ready) {
        var obj = component.createObject(parentObj);
        obj.x = 125;
        obj.y = 125;
    }
}
