import Qt 4.7

Rectangle {
    // Basic hello world example
    id: root
    width: 200
    height: 200
    Text {
        id: text
        x: 66
        y: 93
        text: "Hello World"
    }

    // Declares a state where the text has been rotated 180 degrees
    // The state is entered when mouse left button is pressed
    // within mouseArea
    states: [
        State {
            name: "upsidedown"
            when: mouseArea.pressed
            PropertyChanges {
                target: text
                rotation: 180
            }
        }
    ]

    // Different sequential animations for press and release
    // so the speed stays constant both ways
    // Quizz:
    //  - Remove second transition and run. What happens and why?
    //  - Add reversible: true to the first transtion. What happens?
    //  - Compare original with the reversible solution.
    //    - Why's there a difference?
    //  - Remove reversible, from and to. What happens and why?
    transitions: [
        Transition {
            from: ""; to: "upsidedown"
            SequentialAnimation {
                NumberAnimation { property: "rotation"; to: 360; duration: 500 }
                NumberAnimation { property: "rotation"; duration: 250 }
            }
        },
        Transition {
            from: "upsidedown"; to: ""
            SequentialAnimation {
                NumberAnimation { property: "rotation"; to: 360; duration: 250 }
                NumberAnimation { property: "rotation"; duration: 500 }
            }
        }
    ]

    // Mouse click handler, which toggles between the two states
    MouseArea {
        id: mouseArea
        anchors.fill: parent
    }

}
