import Qt 4.7

Rectangle {

    width: 200
    height: 200

    // View displays the model elements
    ListView {
        anchors.fill: parent
        model: model
        delegate: ExpandingDelegate {}
    }

    // Model can be build statically or dynamically
    ListModel {
        id: model
        ListElement {
            title: "qml1"
            description: "QML-defined element 1"
        }
        ListElement {
            title: "qml2"
            description: "QML-defined element 2"
        }
        ListElement {
            title: "qml3"
            description: "QML-defined element 3"
        }
        ListElement {
            title: "qml4"
            description: "QML-defined element 4"
        }
    }

    Timer {
        property int count: 0
        interval: 1000
        repeat: true
        running: true
        onTriggered: {
            if (count > 3) {
                repeat = false;
            } else {
                count++;

                // Appends an object into the model
                model.append({
                    title: "timer" + count,
                    description: "Element added dynamically " + count
                });
            }
        }
    }

}
