import Qt 4.7

Rectangle {
    width: 200
    height: 200

    ListModel {
        id: model
        ListElement {
            title: "Element 1"
        }
        ListElement {
            title: "Element 2"
        }
        ListElement {
            title: "Element 3"
        }
        ListElement {
            title: "Element 4"
        }
    }

    // In this example the automatic highlight management
    // is turned off and the highlight delegate defines
    // a custom animation which is run when its position changes
    ListView {
        id: view
        anchors.fill: parent
        model: model
        delegate: delegate
        highlight: highlight
        highlightFollowsCurrentItem: false
        focus: true
    }

    // Draws the text of element. The text also
    // contains a MouseArea, which switches the
    // current view index
    // The delegate must not draw a background color
    // since the highlight is drawn behind it
    Component {
        id: delegate
        Text {
            height: 25
            width: view.width
            text: title
            verticalAlignment: Text.AlignVCenter
            x: 10
            MouseArea {
                anchors.fill: parent
                onClicked: view.currentIndex = index
            }
        }
    }

    // Highlight with custom y-movement
    Component {
        id: highlight
        Rectangle {
            height: 25
            color: "yellow"
            width: view.width - 1
            border.width: 1
            radius: 3

            // Highlight follows the current item y-position
            y: view.currentItem.y
            Behavior on y {
                SpringAnimation { spring: 2; damping: 0.1 }
            }
        }
    }
}
